//Shining Laser v3 -- By takato14.
//audio
exec("Add-ons/weapon_Horse_Ray/Server.cs");
datablock AudioProfile(SLCZfireSound)
{
   filename    = "./SLCFire.wav";
   description = AudioClosest3d;
   preload = true;
};

datablock AudioProfile(SLCZExplodeSound)
{
   filename    = "./SLCHit_New.wav";
   description = AudioDefault3d;
   preload = true;
};

//muzzle flash effects
datablock ParticleData(SLCZFlashParticle)
{
	dragCoefficient      = 1;
	gravityCoefficient   = 1.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 1500;
	lifetimeVarianceMS   = 150;
	textureName          = "./shine2.png";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.6 0.6 0.6 0.9";
	colors[1]     = "0.5 0.6 0.9 0.0";
	sizes[0]      = 0.25;
	sizes[1]      = 0.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(SLCZFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 10.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 180;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SLCZFlashParticle";


};

//bullet trail effects
datablock ParticleData(SLCZTrailParticle)
{
	dragCoefficient		= 3.0;
	windCoefficient		= 0.0;
	gravityCoefficient	= 0.0;
	inheritedVelFactor	= 0.0;
	constantAcceleration	= 0.0;
	lifetimeMS		= 3000;
	lifetimeVarianceMS	= 750;
	spinSpeed		= 0.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	useInvAlpha		= true;
	animateTexture		= false;
	//framesPerSec		= 1;

	textureName		= "./shine2";
	//animTexName		= " ";

	// Interpolation variables
	colors[0]	= "0 1 1 1";
	colors[1]	= "0.5 1 1 0.0";
	sizes[0]	= 0.25;
	sizes[1]	= 0.0;
	//times[0]	= 0.8;
	//times[1]	= 0.8;
};

datablock ParticleEmitterData(SLCZTrailEmitter)
{
   

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;

   ejectionVelocity = 0; //0.25;
   velocityVariance = 0; //0.10;

   ejectionOffset = 0;

   thetaMin         = 0.0;
   thetaMax         = 90.0;  

   particles = SLCZTrailParticle;
   useEmitterColors = true;
   uiName = "";
};

datablock ParticleData(SLCZExplosionParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -1.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 1500;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.6 0.9 0.9 0.9";
	colors[1]     = "0.5 0.6 0.9 0.0";
	sizes[0]      = 3.0;
	sizes[1]      = 6.0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(SLCZExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 50;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 0;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SLCZExplosionParticle";


   emitterNode = TenthEmitterNode;
};

datablock ParticleData(SLCZExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -2.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 5000;
	lifetimeVarianceMS   = 135;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 25.0;
	spinRandomMin		= -25.0;
	spinRandomMax		= 25.0;
	colors[0]     = "0.6 0.9 0.9 0.9";
	colors[1]     = "0.5 0.6 0.9 0.0";
	sizes[0]      = 32;
	sizes[1]      = 38;

	useInvAlpha = false;
};
datablock ParticleEmitterData(SLCZExplosionRingEmitter)
{
	lifeTimeMS = 90;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 240;
   velocityVariance = 1.0;
   ejectionOffset   = 20.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SLCZExplosionRingParticle";
};

datablock ParticleData(SLCZBitsParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.15;
	constantAcceleration = 0.0;
	lifetimeMS           = 2500;
	lifetimeVarianceMS   = 805;
	textureName          = "./shine2";
	spinSpeed		= 10.0;
	spinRandomMin		= -150.0;
	spinRandomMax		= 150.0;
	colors[0]     = "0.0 1.0 0.3 0.4";
	colors[1]     = "1.0 0.2 1.0 0.5";
   colors[2]     = "0.10 0.3 0.20 0.3";
   colors[3]     = "0.4 0.7 1.0 0.5";

	sizes[0]      = 0.75;
	sizes[1]      = 1.0;
   sizes[2]      = 1.35;
 	sizes[3]      = 0.05;

   times[0] = 0.0;
   times[1] = 0.05;
   times[2] = 0.3;
   times[3] = 1.0;

	useInvAlpha = false;
};

datablock ParticleEmitterData(SLCZBitsEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 1;
   ejectionVelocity = 0.25;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SLCZBitsParticle";
};

datablock ParticleEmitterData(SLCZChargedEmitter : SLCZBitsEmitter)
{
   ejectionPeriodMS = 8;
   ejectionVelocity = 1;
};


datablock DebrisData(SLCZBitsDebris)
{
   emitters = "SLCZBitsEmitter";

	lifetime = 0.3;
	minSpinSpeed = -300.0;
	maxSpinSpeed = 300.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 0;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = false;

	gravModifier = 1;
};

datablock ExplosionData(SLCZExplosion)
{
   explosionShape = "Add-Ons/Weapon_Rocket_Launcher/explosionSphere1.dts";
	soundProfile = SLCZExplodeSound;

   debris = SLCZBitsDebris;
   debrisNum = 90;
   debrisNumVariance = 0;
   debrisPhiMin = 0;
   debrisPhiMax = 360;
   debrisThetaMin = 0;
   debrisThetaMax = 180;
   debrisVelocity = 80;
   debrisVelocityVariance = 60;
   lifeTimeMS = 250;

   particleEmitter = SLCZExplosionEmitter;
   particleDensity = 100;
   particleRadius = 0.05;

   emitter[0] = "";
   emitter[1] = "";

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "15.0 12.0 25.0";
   camShakeAmp = "10.0 35.0 10.0";
   camShakeDuration = 2;
   camShakeRadius = 100.0;

   // Dynamic light
   lightStartRadius = 5;
   lightEndRadius = 70;
   lightStartColor = "0.2 0.6 0.8 0.9";
   lightEndColor = "0.1 0.2 0.5 1";

   damageRadius = 10;
   radiusDamage = 80;

   impulseRadius = 8;
   impulseForce = 100;
	
   //uiname = "";
};
AddDamageType("SLCZ",  '<bitmap:add-ons/Weapon_ShiningLaser/CI_SLCkill> %1',    '%2 <bitmap:add-ons/Weapon_ShiningLaser/CI_SLCkill> %1',1,1);

datablock ProjectileData(SLCZProjectile)
{
   projectileShapeName = "base/data/shapes/empty.dts";
   directDamage        = 1000;
   directDamageType = $DamageType::SLCZ;
   radiusDamageType = $DamageType::SLCZ;
   impactImpulse	   = 2; //Originally 7000000
   verticalImpulse	   = 2; //Originally 7000000
   explosion           = SLCZExplosion;
   particleEmitter     = SLCZTrailEmitter;

   brickExplosionRadius = 30;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 70;             
   brickExplosionMaxVolume = 290;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 390;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   muzzleVelocity      = 200;
   velInheritFactor    = 1.0;

   armingDelay         = 00;
   lifetime            = 30000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod = 0;

   hasLight    = true;
   lightRadius = 5.0;
   lightColor  = "0 0.5 0.8";

   //uiName = "Shining Laser";
};

//datablock ProjectileData(SLCZProjectileB : SLCZProjectile)
//{
  // directDamage        = 0;
   //impactImpulse	   = 0;
   //verticalImpulse	   = 0;
  // explosion           = "";
  // particleEmitter     = SLCZBitsEmitter;

  // brickExplosionRadius = 0;
  // brickExplosionImpact = true;          //destroy a brick if we hit it directly?
  // brickExplosionForce  = 0;             
  // brickExplosionMaxVolume = 0;          //max volume of bricks that we can destroy
  // brickExplosionMaxVolumeFloating = 0;  //max volume of bricks that we can destroy if they aren't connected to the ground (should always be >= brickExplosionMaxVolume)

   //hasLight    = false;
   
   //uiName = "";
//};

//////////
// item //
//////////
datablock ItemData(SLCZItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./SLC.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Shining Laser";
	iconName = "./ci_SLCicon3";
	doColorShift = false;
	colorShiftColor = "0.100 0.500 0.250 1.000";

	 // Dynamic properties defined by the scripts
	image = SLCZImage;
	canDrop = true;
};
////////////////
//weapon image//
////////////////

datablock ShapeBaseImageData(SLCZStaticImage)
{
   // Basic Item properties
   shapeFile = "./SLC.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 .5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = SLCZProjectile;
   projectileType = Projectile;

	//casing = SLCZShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   LarmReady = false;
   minShotTime = 1700;   //minimum time allowed between shots (needed to prevent equip/dequip exploit)

   doColorShift = true;
   colorShiftColor = "0.100 0.500 0.250 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.2;
	stateTransitionOnTimeout[0]       = "Ready";
		stateScript[0]                  = "onready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
   stateTransitionOnNoAmmo[1]       = "NoAmmo";
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Fire2";
	stateTimeoutValue[2]            = 0.0;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;

	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= SLCZFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= tailNode;
	stateSound[2]					= SLCZFireSound;
   stateSequence[2]                = "Fire";
	//stateEjectShell[2]       = true;

stateName[3]                    = "Fire2";
	stateTransitionOnTimeout[3]     = "smoke";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;

	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]			= true;
	stateEmitter[3]					= SLCZFlashEmitter;
	stateEmitterTime[3]				= 0.05;
	stateEmitterNode[3]				= tailNode;
	stateSound[3]					= SLCZFireSound;
   stateSequence[3]                = "Fire";
	//stateEjectShell[2]       = true;


	stateName[4] = "Smoke";
	stateEmitterTime[4]				= 0.05;
	stateEmitterNode[4]				= "muzzleNode";
	stateTimeoutValue[4]            = 0.4;
   stateSequence[4]                = "TrigDown";
	stateTransitionOnTimeout[4]     = "CoolDown";

   stateName[5] = "CoolDown";
   stateTimeoutValue[5]            = 1.3;
	stateTransitionOnTimeout[5]     = "Reload";
   stateSequence[5]                = "TrigDown";


	stateName[6]			= "Reload";
	stateTransitionOnTriggerUp[6]     = "Ready";
	stateSequence[6] = "TrigDown";

   stateName[7]   = "NoAmmo";
   stateTransitionOnAmmo[7] = "Ready";
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(SLCZImage)
{
   // Basic Item properties
   shapeFile = "./SLC.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 .5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = SLCZProjectile;
   projectileType = Projectile;

	//casing = SLCZShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;
   LarmReady = false;
   minShotTime = 2500;   //minimum time allowed between shots (needed to prevent equip/dequip exploit)

   doColorShift = true;
   colorShiftColor = "0.100 0.500 0.250 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]			= "Activate";
	stateTimeoutValue[0]		= 0.1;
	stateTransitionOnTimeout[0]	= "Ready";
	stateSequence[0]		= "idle";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]			= "Ready";
	stateTransitionOnTriggerDown[1]	= "Charge";
	stateAllowImageChange[1]	= true;
	
	stateName[2]                    = "Charge";
	stateTransitionOnTimeout[2]	= "Armed";
	stateTimeoutValue[2]            = 0.7;
	stateWaitForTimeout[2]		= false;
	stateTransitionOnTriggerUp[2]	= "AbortCharge";
	stateScript[2]                  = "onCharge";
	stateAllowImageChange[2]        = false;
	stateSequence[2]			= "chargeBegin";
	
	stateName[3]			= "AbortCharge";
	stateTransitionOnTimeout[3]	= "Ready";
	stateTimeoutValue[3]		= 0.3;
	stateWaitForTimeout[3]		= true;
	stateScript[3]			= "onAbortCharge";
	stateAllowImageChange[3]	= false;
	stateSequence[3]		= "idle";

	stateName[4]			= "Armed";
	stateTransitionOnTriggerUp[4]	= "Fire";
	stateTransitionOnTimeout[4]	= "ChargeFull";
	stateTimeoutValue[4]			= 5;
	stateEmitter[4]			= horseRaySmokeEmitter;
	stateEmitterTime[4]		= 5;
	stateWaitForTimeout[4] = false;
	stateAllowImageChange[4]	= false;
	stateSequence[4]		= "chargeTremble";

	stateName[5]			= "Fire";
	stateTransitionOnTimeout[5]	= "Ready";
	stateTimeoutValue[5]		= 0.5;
	stateFire[5]			= true;
	stateSequence[5]		= "fire";
	stateScript[5]			= "onFire";
	stateWaitForTimeout[5]		= true;
	stateAllowImageChange[5]	= false;
	stateSound[5]				= SLCZFireSound;
	stateSequence[5]		= "launchBeam";
	
	stateName[6]			= "ChargeFull";
	stateTransitionOnTriggerUp[6]	= "Fire";
	stateTransitionOnTriggerDown[6]	= "ChargeFull";
	stateEmitter[6]			= SLCZChargedEmitter;
	stateEmitterTime[6]		= 1;
	stateEmitterNode[6]		= "muzzleNode";
	stateAllowImageChange[6]	= false;
	stateSequence[6]		= "chargeTremble";
};

function SLCZImage::onCharge(%this, %obj, %slot)
{
	%obj.client.saved_time = getSimTime();
}

function SLCZImage::onFire(%this,%obj,%slot)
{
	%projectile = SLCZProjectile;
	%charge_time = getSimTime() - %obj.client.saved_time;
	%shellCount = 1;
	if(%charge_Time <= 500.0)
	{
		%scaleFactor = 0.25;
		SLCZexplosion.emitter[0] = "";//**SEE BELOW**//
		SLCZExplosion.damageRadius = 50;
   		SLCZExplosion.radiusDamage = 50;
		SLCZExplosion.impulseForce = 1;
		SLCZProjectile.impactImpulse = 5;
		SLCZProjectile.verticalImpulse = 5;

	}
	else
	{
		%scaleFactor = 0.25;
		SLCZexplosion.emitter[0] = "";//**SEE BELOW**//
		SLCZExplosion.damageRadius = 5;
   		SLCZExplosion.radiusDamage = 50;
		SLCZExplosion.impulseForce = 10;
		SLCZProjectile.impactImpulse = 10;
		SLCZProjectile.verticalImpulse = 10;

	}
	if(%charge_Time >= 1000.0)
	{
		%scaleFactor = 0.5;
		SLCZexplosion.emitter[0] = "";//**SEE BELOW**//
		SLCZExplosion.damageRadius = 7.5;
   		SLCZExplosion.radiusDamage = 75;
		SLCZExplosion.impulseForce = 25;
		SLCZProjectile.impactImpulse = 20;
		SLCZProjectile.verticalImpulse = 20;

	}
	if(%charge_Time >= 2000.0)
	{
		%scaleFactor = 1.0;
		SLCZexplosion.emitter[0] = "";//**SEE BELOW**//
		SLCZExplosion.damageRadius = 10;
   		SLCZExplosion.radiusDamage = 100;
		SLCZExplosion.impulseForce = 50;
		SLCZProjectile.impactImpulse = 50;
		SLCZProjectile.verticalImpulse = 50;
	}
	if(%charge_Time >= 5000.0)
	{
		%scaleFactor = 2.0;
		SLCZProjectile.directDamage = 10000;//**SEE BELOW**//
		SLCZexplosion.emitter[0] = SLCZexplosionRingemitter;
		SLCZExplosion.damageRadius = 20;
		SLCZExplosion.RadiusDamage = 10000;//**SEE BELOW**//
		SLCZProjectile.impactImpulse = 500000;
		SLCZProjectile.verticalImpulse = 500000;

	}

	%client = %obj.client;
	%pos = %obj.getHackPosition();

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = vectorScale(%obj.getMuzzleVector(%slot), 200);
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		//echo("Scale Factor:" SPC %scaleFactor);
%p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
		missionCleanup.add(%p);
	}
	return %p;
	SLCZExplosion.emitter[0] = ""; //**SEE BELOW**//
	SLCZProjectile.directDamage = 1000;//**SEE BELOW**//
	SLCZExplosion.damageRadius = 10;
	SLCZExplosion.radiusDamage = 100;
	SLCZProjectile.impactImpulse = 0;
	SLCZProjectile.verticalImpulse = 0;
//**It is safe to use these args because the values are switched back and forth so quickly that even if two people's images overlapped, they would have experienced the same fire result anyways. 
}

/////////////////
//--RTB PREFS--//
/////////////////
//RTB users can customize the restrictions on this weapon to their liking. For non-RTB users, you can set these values yourself:

//$fullAllowed = 1; //Whether or not the SLC charges for the beam

if(isFile("Add-Ons/System_ReturnToBlockland/server.cs"))
{
    if(!$RTB::RTBR_ServerControl_Hook)
	exec("Add-Ons/System_ReturnToBlockland/RTBR_ServerControl_Hook.cs");
  
    RTB_registerPref("Chargeable Laser", "Shining Laser", "$fullAllowed", "bool", 0, 0, 1);

}
if($fullAllowed == 1)
{
	SLCZItem.Image = SLCZImage;
}
else
{
	SLCZItem.image = SLCZStaticImage;
}

//exec("./Laser_Arc.cs"); //exec code for an easily toggleable system. This function is buggy and potentially unsafe, but Im leaving it here if you want to try using it.
